Index: src/language/lexer/variable-parser.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/lexer/variable-parser.c,v
retrieving revision 1.10
diff -b -w -U3 -r1.10 variable-parser.c
--- src/language/lexer/variable-parser.c	26 Oct 2006 06:16:36 -0000	1.10
+++ src/language/lexer/variable-parser.c	11 Nov 2006 00:13:17 -0000
@@ -44,23 +44,24 @@
    variable's index and returns true if successful.  On failure
    emits an error message and returns false. */
 static bool
-parse_vs_variable_idx (const struct var_set *vs, size_t *idx)
+parse_vs_variable_idx (struct lexer *lexer, const struct var_set *vs, 
+		size_t *idx)
 {
   assert (idx != NULL);
   
-  if (token != T_ID)
+  if (lex_token (lexer) != T_ID)
     {
-      lex_error (_("expecting variable name"));
+      lex_error (lexer, _("expecting variable name"));
       return false;
     }
-  else if (var_set_lookup_var_idx (vs, tokid, idx)) 
+  else if (var_set_lookup_var_idx (vs, lex_tokid (lexer), idx)) 
     {
-      lex_get ();
+      lex_get (lexer);
       return true;
     }
   else 
     {
-      msg (SE, _("%s is not a variable name."), tokid);
+      msg (SE, _("%s is not a variable name."), lex_tokid (lexer));
       return false;
     }
 }
@@ -69,20 +70,20 @@
    if successful.  On failure emits an error message and returns
    a null pointer. */
 static struct variable *
-parse_vs_variable (const struct var_set *vs)
+parse_vs_variable (struct lexer *lexer, const struct var_set *vs)
 {
   size_t idx;
-  return parse_vs_variable_idx (vs, &idx) ? var_set_get_var (vs, idx) : NULL;
+  return parse_vs_variable_idx (lexer, vs, &idx) ? var_set_get_var (vs, idx) : NULL;
 }
 
 /* Parses a variable name in dictionary D and returns the
    variable if successful.  On failure emits an error message and
    returns a null pointer. */
 struct variable *
-parse_variable (const struct dictionary *d) 
+parse_variable (struct lexer *lexer, const struct dictionary *d) 
 {
   struct var_set *vs = var_set_create_from_dict (d);
-  struct variable *var = parse_vs_variable (vs);
+  struct variable *var = parse_vs_variable (lexer, vs);
   var_set_destroy (vs);
   return var;
 }
@@ -92,7 +93,8 @@
    number of variables into *CNT.  Returns true only if
    successful. */
 bool
-parse_variables (const struct dictionary *d, struct variable ***var,
+parse_variables (struct lexer *lexer, const struct dictionary *d, 
+			struct variable ***var,
                  size_t *cnt, int opts) 
 {
   struct var_set *vs;
@@ -103,7 +105,7 @@
   assert (cnt != NULL);
 
   vs = var_set_create_from_dict (d);
-  success = parse_var_set_vars (vs, var, cnt, opts);
+  success = parse_var_set_vars (lexer, vs, var, cnt, opts);
   if ( success == 0 )
      free ( *var ) ;
   var_set_destroy (vs);
@@ -116,7 +118,8 @@
    successful.  Same behavior as parse_variables, except that all
    allocations are taken from the given POOL. */
 bool
-parse_variables_pool (struct pool *pool, const struct dictionary *dict,
+parse_variables_pool (struct lexer *lexer, struct pool *pool, 
+		const struct dictionary *dict,
                       struct variable ***vars, size_t *var_cnt, int opts) 
 {
   int retval;
@@ -127,7 +130,7 @@
      later. */
   assert (!(opts & PV_APPEND));
   
-  retval = parse_variables (dict, vars, var_cnt, opts);
+  retval = parse_variables (lexer, dict, vars, var_cnt, opts);
   if (retval)
     pool_register (pool, free, *vars);
   return retval;
@@ -138,10 +141,11 @@
    dictionary class, and returns true.  Returns false on
    failure. */
 static bool
-parse_var_idx_class (const struct var_set *vs, size_t *idx,
+parse_var_idx_class (struct lexer *lexer, const struct var_set *vs, 
+			size_t *idx,
                      enum dict_class *class)
 {
-  if (!parse_vs_variable_idx (vs, idx))
+  if (!parse_vs_variable_idx (lexer, vs, idx))
     return false;
 
   *class = dict_class_from_id (var_set_get_var (vs, *idx)->name);
@@ -212,7 +216,7 @@
    Conversely, if parse_variables() returns true, then *nv is
    nonzero and *v is non-NULL. */
 bool
-parse_var_set_vars (const struct var_set *vs, 
+parse_var_set_vars (struct lexer *lexer, const struct var_set *vs, 
                     struct variable ***v, size_t *nv,
                     int pv_opts)
 {
@@ -254,7 +258,7 @@
 
   do
     {
-      if (lex_match (T_ALL))
+      if (lex_match (lexer, T_ALL))
         add_variables (v, nv, &mv, included, pv_opts,
                        vs, 0, var_set_get_cnt (vs) - 1, DC_ORDINARY);
       else 
@@ -262,10 +266,10 @@
           enum dict_class class;
           size_t first_idx;
 
-          if (!parse_var_idx_class (vs, &first_idx, &class))
+          if (!parse_var_idx_class (lexer, vs, &first_idx, &class))
             goto fail;
 
-          if (!lex_match (T_TO))
+          if (!lex_match (lexer, T_TO))
             add_variable (v, nv, &mv, included, pv_opts, vs, first_idx);
           else 
             {
@@ -273,7 +277,7 @@
               enum dict_class last_class;
               struct variable *first_var, *last_var;
 
-              if (!parse_var_idx_class (vs, &last_idx, &last_class))
+              if (!parse_var_idx_class (lexer, vs, &last_idx, &last_class))
                 goto fail;
 
               first_var = var_set_get_var (vs, first_idx);
@@ -307,10 +311,10 @@
 
       if (pv_opts & PV_SINGLE)
         break;
-      lex_match (',');
+      lex_match (lexer, ',');
     }
-  while (token == T_ALL
-         || (token == T_ID && var_set_lookup_var (vs, tokid) != NULL));
+  while (lex_token (lexer) == T_ALL
+         || (lex_token (lexer) == T_ID && var_set_lookup_var (vs, lex_tokid (lexer)) != NULL));
   
   if (*nv == 0)
     goto fail;
@@ -372,7 +376,7 @@
 /* Parses a list of variable names according to the DATA LIST version
    of the TO convention.  */
 bool
-parse_DATA_LIST_vars (char ***names, size_t *nnames, int pv_opts)
+parse_DATA_LIST_vars (struct lexer *lexer, char ***names, size_t *nnames, int pv_opts)
 {
   int n1, n2;
   int d1, d2;
@@ -398,29 +402,29 @@
 
   do
     {
-      if (token != T_ID)
+      if (lex_token (lexer) != T_ID)
 	{
-	  lex_error ("expecting variable name");
+	  lex_error (lexer, "expecting variable name");
 	  goto fail;
 	}
-      if (dict_class_from_id (tokid) == DC_SCRATCH
+      if (dict_class_from_id (lex_tokid (lexer)) == DC_SCRATCH
           && (pv_opts & PV_NO_SCRATCH))
 	{
 	  msg (SE, _("Scratch variables not allowed here."));
 	  goto fail;
 	}
-      strcpy (name1, tokid);
-      lex_get ();
-      if (token == T_TO)
+      strcpy (name1, lex_tokid (lexer));
+      lex_get (lexer);
+      if (lex_token (lexer) == T_TO)
 	{
-	  lex_get ();
-	  if (token != T_ID)
+	  lex_get (lexer);
+	  if (lex_token (lexer) != T_ID)
 	    {
-	      lex_error ("expecting variable name");
+	      lex_error (lexer, "expecting variable name");
 	      goto fail;
 	    }
-	  strcpy (name2, tokid);
-	  lex_get ();
+	  strcpy (name2, lex_tokid (lexer));
+	  lex_get (lexer);
 
 	  if (!extract_num (name1, root1, &n1, &d1)
 	      || !extract_num (name2, root2, &n2, &d2))
@@ -463,12 +467,12 @@
 	  (*names)[nvar++] = xstrdup (name1);
 	}
 
-      lex_match (',');
+      lex_match (lexer, ',');
 
       if (pv_opts & PV_SINGLE)
 	break;
     }
-  while (token == T_ID);
+  while (lex_token (lexer) == T_ID);
   success = 1;
 
 fail:
@@ -502,7 +506,7 @@
    parse_DATA_LIST_vars(), except that all allocations are taken
    from the given POOL. */
 bool
-parse_DATA_LIST_vars_pool (struct pool *pool,
+parse_DATA_LIST_vars_pool (struct lexer *lexer, struct pool *pool,
                            char ***names, size_t *nnames, int pv_opts)
 {
   int retval;
@@ -513,7 +517,7 @@
      re-free it later. */
   assert (!(pv_opts & PV_APPEND));
   
-  retval = parse_DATA_LIST_vars (names, nnames, pv_opts);
+  retval = parse_DATA_LIST_vars (lexer, names, nnames, pv_opts);
   if (retval)
     register_vars_pool (pool, *names, *nnames);
   return retval;
@@ -523,7 +527,7 @@
    existing and the rest are to be created.  Same args as
    parse_DATA_LIST_vars(). */
 bool
-parse_mixed_vars (const struct dictionary *dict, 
+parse_mixed_vars (struct lexer *lexer, const struct dictionary *dict, 
 		  char ***names, size_t *nnames, int pv_opts)
 {
   size_t i;
@@ -537,14 +541,14 @@
       *names = NULL;
       *nnames = 0;
     }
-  while (token == T_ID || token == T_ALL)
+  while (lex_token (lexer) == T_ID || lex_token (lexer) == T_ALL)
     {
-      if (token == T_ALL || dict_lookup_var (dict, tokid) != NULL)
+      if (lex_token (lexer) == T_ALL || dict_lookup_var (dict, lex_tokid (lexer)) != NULL)
 	{
 	  struct variable **v;
 	  size_t nv;
 
-	  if (!parse_variables (dict, &v, &nv, PV_NONE))
+	  if (!parse_variables (lexer, dict, &v, &nv, PV_NONE))
 	    goto fail;
 	  *names = xnrealloc (*names, *nnames + nv, sizeof **names);
 	  for (i = 0; i < nv; i++)
@@ -552,7 +556,7 @@
 	  free (v);
 	  *nnames += nv;
 	}
-      else if (!parse_DATA_LIST_vars (names, nnames, PV_APPEND))
+      else if (!parse_DATA_LIST_vars (lexer, names, nnames, PV_APPEND))
 	goto fail;
     }
   return 1;
@@ -571,7 +575,7 @@
    parse_mixed_vars(), except that all allocations are taken
    from the given POOL. */
 bool
-parse_mixed_vars_pool (const struct dictionary *dict, struct pool *pool,
+parse_mixed_vars_pool (struct lexer *lexer, const struct dictionary *dict, struct pool *pool,
                        char ***names, size_t *nnames, int pv_opts)
 {
   int retval;
@@ -582,7 +586,7 @@
      re-free it later. */
   assert (!(pv_opts & PV_APPEND));
 
-  retval = parse_mixed_vars (dict, names, nnames, pv_opts);
+  retval = parse_mixed_vars (lexer, dict, names, nnames, pv_opts);
   if (retval)
     register_vars_pool (pool, *names, *nnames);
   return retval;
Index: src/language/lexer/variable-parser.h
===================================================================
RCS file: /sources/pspp/pspp/src/language/lexer/variable-parser.h,v
retrieving revision 1.4
diff -b -w -U3 -r1.4 variable-parser.h
--- src/language/lexer/variable-parser.h	26 Oct 2006 06:16:36 -0000	1.4
+++ src/language/lexer/variable-parser.h	11 Nov 2006 00:13:17 -0000
@@ -27,6 +27,7 @@
 struct dictionary;
 struct var_set;
 struct variable;
+struct lexer ;
 
 struct var_set *var_set_create_from_dict (const struct dictionary *d);
 struct var_set *var_set_create_from_array (struct variable *const *var,
@@ -55,19 +56,19 @@
     PV_NO_SCRATCH = 00200 	/* Disallow scratch variables. */
   };
 
-struct variable *parse_variable (const struct dictionary *);
-bool parse_variables (const struct dictionary *, struct variable ***, size_t *,
+struct variable *parse_variable (struct lexer *, const struct dictionary *);
+bool parse_variables (struct lexer *, const struct dictionary *, struct variable ***, size_t *,
                      int opts);
-bool parse_variables_pool (struct pool *, const struct dictionary *,
+bool parse_variables_pool (struct lexer *, struct pool *, const struct dictionary *,
                           struct variable ***, size_t *, int opts);
-bool parse_var_set_vars (const struct var_set *, struct variable ***, size_t *,
+bool parse_var_set_vars (struct lexer *, const struct var_set *, struct variable ***, size_t *,
                         int opts);
-bool parse_DATA_LIST_vars (char ***names, size_t *cnt, int opts);
-bool parse_DATA_LIST_vars_pool (struct pool *,
+bool parse_DATA_LIST_vars (struct lexer *, char ***names, size_t *cnt, int opts);
+bool parse_DATA_LIST_vars_pool (struct lexer *, struct pool *,
                                char ***names, size_t *cnt, int opts);
-bool parse_mixed_vars (const struct dictionary *dict, 
+bool parse_mixed_vars (struct lexer *, const struct dictionary *dict, 
 		       char ***names, size_t *cnt, int opts);
-bool parse_mixed_vars_pool (const struct dictionary *dict, 
+bool parse_mixed_vars_pool (struct lexer *, const struct dictionary *dict, 
 			    struct pool *,
                            char ***names, size_t *cnt, int opts);
 
Index: src/language/stats/aggregate.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/aggregate.c,v
retrieving revision 1.18
diff -b -w -U3 -r1.18 aggregate.c
--- src/language/stats/aggregate.c	3 Nov 2006 04:53:51 -0000	1.18
+++ src/language/stats/aggregate.c	11 Nov 2006 00:13:17 -0000
@@ -155,7 +155,7 @@
                                        const struct ccase *);
 
 /* Prototypes. */
-static bool parse_aggregate_functions (const struct dictionary *,
+static bool parse_aggregate_functions (struct lexer *, const struct dictionary *,
 				       struct agr_proc *);
 static void agr_destroy (struct agr_proc *);
 static bool aggregate_single_case (struct agr_proc *agr,
@@ -173,7 +173,7 @@
 
 /* Parses and executes the AGGREGATE procedure. */
 int
-cmd_aggregate (struct dataset *ds)
+cmd_aggregate (struct lexer *lexer, struct dataset *ds)
 {
   struct dictionary *dict = dataset_dict (ds);
   struct agr_proc agr;
@@ -193,12 +193,12 @@
   dict_set_documents (agr.dict, dict_get_documents (dict));
 
   /* OUTFILE subcommand must be first. */
-  if (!lex_force_match_id ("OUTFILE"))
+  if (!lex_force_match_id (lexer, "OUTFILE"))
     goto error;
-  lex_match ('=');
-  if (!lex_match ('*'))
+  lex_match (lexer, '=');
+  if (!lex_match (lexer, '*'))
     {
-      out_file = fh_parse (FH_REF_FILE | FH_REF_SCRATCH);
+      out_file = fh_parse (lexer, FH_REF_FILE | FH_REF_SCRATCH);
       if (out_file == NULL)
         goto error;
     }
@@ -206,28 +206,28 @@
   /* Read most of the subcommands. */
   for (;;)
     {
-      lex_match ('/');
+      lex_match (lexer, '/');
       
-      if (lex_match_id ("MISSING"))
+      if (lex_match_id (lexer, "MISSING"))
 	{
-	  lex_match ('=');
-	  if (!lex_match_id ("COLUMNWISE"))
+	  lex_match (lexer, '=');
+	  if (!lex_match_id (lexer, "COLUMNWISE"))
 	    {
-	      lex_error (_("while expecting COLUMNWISE"));
+	      lex_error (lexer, _("while expecting COLUMNWISE"));
               goto error;
 	    }
 	  agr.missing = COLUMNWISE;
 	}
-      else if (lex_match_id ("DOCUMENT"))
+      else if (lex_match_id (lexer, "DOCUMENT"))
         copy_documents = true;
-      else if (lex_match_id ("PRESORTED"))
+      else if (lex_match_id (lexer, "PRESORTED"))
         presorted = true;
-      else if (lex_match_id ("BREAK"))
+      else if (lex_match_id (lexer, "BREAK"))
 	{
           int i;
 
-	  lex_match ('=');
-          agr.sort = sort_parse_criteria (dict,
+	  lex_match (lexer, '=');
+          agr.sort = sort_parse_criteria (lexer, dict,
                                           &agr.break_vars, &agr.break_var_cnt,
                                           &saw_direction, NULL);
           if (agr.sort == NULL)
@@ -242,7 +242,7 @@
 	}
       else
         {
-          lex_error (_("expecting BREAK"));
+          lex_error (lexer, _("expecting BREAK"));
           goto error;
         }
     }
@@ -252,8 +252,8 @@
                "the same way as the input data."));
       
   /* Read in the aggregate functions. */
-  lex_match ('/');
-  if (!parse_aggregate_functions (dict, &agr))
+  lex_match (lexer, '/');
+  if (!parse_aggregate_functions (lexer, dict, &agr))
     goto error;
 
   /* Delete documents. */
@@ -359,7 +359,7 @@
 
 /* Parse all the aggregate functions. */
 static bool
-parse_aggregate_functions (const struct dictionary *dict, struct agr_proc *agr)
+parse_aggregate_functions (struct lexer *lexer, const struct dictionary *dict, struct agr_proc *agr)
 {
   struct agr_var *tail; /* Tail of linked list starting at agr->vars. */
 
@@ -370,6 +370,7 @@
       char **dest;
       char **dest_label;
       size_t n_dest;
+      struct string function_name;
 
       int include_missing;
       const struct agr_func *function;
@@ -392,11 +393,11 @@
       arg[1].c = NULL;
 
       /* Parse the list of target variables. */
-      while (!lex_match ('='))
+      while (!lex_match (lexer, '='))
 	{
 	  size_t n_dest_prev = n_dest;
 	  
-	  if (!parse_DATA_LIST_vars (&dest, &n_dest,
+	  if (!parse_DATA_LIST_vars (lexer, &dest, &n_dest,
                                      PV_APPEND | PV_SINGLE | PV_NO_SCRATCH))
 	    goto error;
 
@@ -409,41 +410,49 @@
 	      dest_label[j] = NULL;
 	  }
 	  
-	  if (token == T_STRING)
+
+	  
+	  if (lex_token (lexer) == T_STRING)
 	    {
-	      ds_truncate (&tokstr, 255);
-	      dest_label[n_dest - 1] = ds_xstrdup (&tokstr);
-	      lex_get ();
+	      struct string label;
+	      ds_init_string (&label, lex_tokstr (lexer));
+
+	      ds_truncate (&label, 255);
+	      dest_label[n_dest - 1] = ds_xstrdup (&label);
+	      lex_get (lexer);
 	    }
 	}
 
       /* Get the name of the aggregation function. */
-      if (token != T_ID)
+      if (lex_token (lexer) != T_ID)
 	{
-	  lex_error (_("expecting aggregation function"));
+	  lex_error (lexer, _("expecting aggregation function"));
 	  goto error;
 	}
 
       include_missing = 0;
-      if (tokid[strlen (tokid) - 1] == '.')
-	{
+
+      ds_init_string (&function_name, lex_tokstr (lexer));
+
+      ds_chomp (&function_name, '.');
+
+      if (lex_tokid(lexer)[strlen (lex_tokid (lexer)) - 1] == '.')
 	  include_missing = 1;
-	  tokid[strlen (tokid) - 1] = 0;
-	}
       
       for (function = agr_func_tab; function->name; function++)
-	if (!strcasecmp (function->name, tokid))
+	if (!strcasecmp (function->name, ds_cstr (&function_name)))
 	  break;
       if (NULL == function->name)
 	{
-	  msg (SE, _("Unknown aggregation function %s."), tokid);
+	  msg (SE, _("Unknown aggregation function %s."), 
+	       ds_cstr (&function_name));
 	  goto error;
 	}
       func_index = function - agr_func_tab;
-      lex_get ();
+      lex_get (lexer);
 
       /* Check for leading lparen. */
-      if (!lex_match ('('))
+      if (!lex_match (lexer, '('))
 	{
 	  if (func_index == N)
 	    func_index = N_NO_VARS;
@@ -451,7 +460,7 @@
 	    func_index = NU_NO_VARS;
 	  else
 	    {
-	      lex_error (_("expecting `('"));
+	      lex_error (lexer, _("expecting `('"));
 	      goto error;
 	    }
 	}
@@ -466,7 +475,7 @@
 	    else if (function->n_args)
 	      pv_opts |= PV_SAME_TYPE;
 
-	    if (!parse_variables (dict, &src, &n_src, pv_opts))
+	    if (!parse_variables (lexer, dict, &src, &n_src, pv_opts))
 	      goto error;
 	  }
 
@@ -477,15 +486,15 @@
 	      {
 		int type;
 	    
-		lex_match (',');
-		if (token == T_STRING)
+		lex_match (lexer, ',');
+		if (lex_token (lexer) == T_STRING)
 		  {
-		    arg[i].c = ds_xstrdup (&tokstr);
+		    arg[i].c = ds_xstrdup (lex_tokstr (lexer));
 		    type = ALPHA;
 		  }
-		else if (lex_is_number ())
+		else if (lex_is_number (lexer))
 		  {
-		    arg[i].f = tokval;
+		    arg[i].f = lex_tokval (lexer);
 		    type = NUMERIC;
 		  } else {
 		    msg (SE, _("Missing argument %d to %s."), i + 1,
@@ -493,7 +502,7 @@
 		    goto error;
 		  }
 	    
-		lex_get ();
+		lex_get (lexer);
 
 		if (type != src[0]->type)
 		  {
@@ -505,9 +514,9 @@
 	      }
 
 	  /* Trailing rparen. */
-	  if (!lex_match(')'))
+	  if (!lex_match (lexer, ')'))
 	    {
-	      lex_error (_("expecting `)'"));
+	      lex_error (lexer, _("expecting `)'"));
 	      goto error;
 	    }
 	  
@@ -649,12 +658,12 @@
       free (dest);
       free (dest_label);
 
-      if (!lex_match ('/'))
+      if (!lex_match (lexer, '/'))
 	{
-	  if (token == '.')
+	  if (lex_token (lexer) == '.')
 	    return true;
 
-	  lex_error ("expecting end of command");
+	  lex_error (lexer, "expecting end of command");
 	  return false;
 	}
       continue;
@@ -1106,7 +1115,8 @@
 /* Aggregate the current case and output it if we passed a
    breakpoint. */
 static bool
-presorted_agr_to_sysfile (const struct ccase *c, void *agr_, const struct dataset *ds UNUSED) 
+presorted_agr_to_sysfile (const struct ccase *c, void *agr_, 
+			  const struct dataset *ds UNUSED) 
 {
   struct agr_proc *agr = agr_;
 
Index: src/language/stats/autorecode.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/autorecode.c,v
retrieving revision 1.13
diff -b -w -U3 -r1.13 autorecode.c
--- src/language/stats/autorecode.c	29 Oct 2006 09:51:36 -0000	1.13
+++ src/language/stats/autorecode.c	11 Nov 2006 00:13:17 -0000
@@ -102,7 +102,7 @@
 
 /* Performs the AUTORECODE procedure. */
 int
-cmd_autorecode (struct dataset *ds)
+cmd_autorecode (struct lexer *lexer, struct dataset *ds)
 {
   struct autorecode_pgm arc;
   size_t dst_cnt;
@@ -119,15 +119,15 @@
   arc.print = 0;
   dst_cnt = 0;
 
-  lex_match_id ("VARIABLES");
-  lex_match ('=');
-  if (!parse_variables (dataset_dict (ds), &arc.src_vars, &arc.var_cnt,
+  lex_match_id (lexer, "VARIABLES");
+  lex_match (lexer, '=');
+  if (!parse_variables (lexer, dataset_dict (ds), &arc.src_vars, &arc.var_cnt,
                         PV_NO_DUPLICATE))
     goto lossage;
-  if (!lex_force_match_id ("INTO"))
+  if (!lex_force_match_id (lexer, "INTO"))
     goto lossage;
-  lex_match ('=');
-  if (!parse_DATA_LIST_vars (&arc.dst_names, &dst_cnt, PV_NONE))
+  lex_match (lexer, '=');
+  if (!parse_DATA_LIST_vars (lexer, &arc.dst_names, &dst_cnt, PV_NONE))
     goto lossage;
   if (dst_cnt != arc.var_cnt)
     {
@@ -144,14 +144,14 @@
 
       goto lossage;
     }
-  while (lex_match ('/'))
-    if (lex_match_id ("DESCENDING"))
+  while (lex_match (lexer, '/'))
+    if (lex_match_id (lexer, "DESCENDING"))
       arc.direction = DESCENDING;
-    else if (lex_match_id ("PRINT"))
+    else if (lex_match_id (lexer, "PRINT"))
       arc.print = 1;
-  if (token != '.')
+  if (lex_token (lexer) != '.')
     {
-      lex_error (_("expecting end of command"));
+      lex_error (lexer, _("expecting end of command"));
       goto lossage;
     }
 
Index: src/language/stats/correlations.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/correlations.q,v
retrieving revision 1.13
diff -b -w -U3 -r1.13 correlations.q
--- src/language/stats/correlations.q	26 Oct 2006 06:16:36 -0000	1.13
+++ src/language/stats/correlations.q	11 Nov 2006 00:13:17 -0000
@@ -46,12 +46,12 @@
 static struct file_handle *matrix_file;
 
 static void free_correlations_state (void);
-static int internal_cmd_correlations (struct dataset *ds);
+static int internal_cmd_correlations (struct lexer *lexer, struct dataset *ds);
 
 int
-cmd_correlations (struct dataset *ds)
+cmd_correlations (struct lexer *lexer, struct dataset *ds)
 {
-  int result = internal_cmd_correlations (ds);
+  int result = internal_cmd_correlations (lexer, ds);
   free_correlations_state ();
   return result;
 }
@@ -71,14 +71,14 @@
 /* (functions) */
 
 int
-internal_cmd_correlations (struct dataset *ds)
+internal_cmd_correlations (struct lexer *lexer, struct dataset *ds)
 {
   struct cmd_correlations cmd;
 
   cor_list = cor_last = NULL;
   matrix_file = NULL;
 
-  if (!parse_correlations (ds, &cmd, NULL))
+  if (!parse_correlations (lexer, ds, &cmd, NULL))
     return CMD_FAILURE;
 
   free_correlations (&cmd);
@@ -87,26 +87,26 @@
 }
 
 static int
-cor_custom_variables (struct dataset *ds, struct cmd_correlations *cmd UNUSED, void *aux UNUSED)
+cor_custom_variables (struct lexer *lexer, struct dataset *ds, struct cmd_correlations *cmd UNUSED, void *aux UNUSED)
 {
   struct variable **v1, **v2;
   size_t nv1, nv2;
   struct cor_set *cor;
 
   /* Ensure that this is a VARIABLES subcommand. */
-  if (!lex_match_id ("VARIABLES")
-      && (token != T_ID || dict_lookup_var (dataset_dict (ds), tokid) != NULL)
-      && token != T_ALL)
+  if (!lex_match_id (lexer, "VARIABLES")
+      && (lex_token (lexer) != T_ID || dict_lookup_var (dataset_dict (ds), lex_tokid (lexer)) != NULL)
+      && lex_token (lexer) != T_ALL)
     return 2;
-  lex_match ('=');
+  lex_match (lexer, '=');
 
-  if (!parse_variables (dataset_dict (ds), &v1, &nv1,
+  if (!parse_variables (lexer, dataset_dict (ds), &v1, &nv1,
 			PV_NO_DUPLICATE | PV_NUMERIC))
     return 0;
   
-  if (lex_match (T_WITH))
+  if (lex_match (lexer, T_WITH))
     {
-      if (!parse_variables (dataset_dict (ds), &v2, &nv2,
+      if (!parse_variables (lexer, dataset_dict (ds), &v2, &nv2,
 			    PV_NO_DUPLICATE | PV_NUMERIC))
 	{
 	  free (v1);
@@ -134,21 +134,21 @@
 }
 
 static int
-cor_custom_matrix (struct dataset *ds UNUSED, struct cmd_correlations *cmd UNUSED, void *aux UNUSED)
+cor_custom_matrix (struct lexer *lexer, struct dataset *ds UNUSED, struct cmd_correlations *cmd UNUSED, void *aux UNUSED)
 {
-  if (!lex_force_match ('('))
+  if (!lex_force_match (lexer, '('))
     return 0;
   
-  if (lex_match ('*'))
+  if (lex_match (lexer, '*'))
     matrix_file = NULL;
   else 
     {
-      matrix_file = fh_parse (FH_REF_FILE);
+      matrix_file = fh_parse (lexer, FH_REF_FILE);
       if (matrix_file == NULL)
         return 0; 
     }
 
-  if (!lex_force_match (')'))
+  if (!lex_force_match (lexer, ')'))
     return 0;
 
   return 1;
Index: src/language/stats/crosstabs.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/crosstabs.q,v
retrieving revision 1.21
diff -b -w -U3 -r1.21 crosstabs.q
--- src/language/stats/crosstabs.q	5 Nov 2006 05:20:53 -0000	1.21
+++ src/language/stats/crosstabs.q	11 Nov 2006 00:13:18 -0000
@@ -176,7 +176,7 @@
 static struct pool *pl_tc;	/* For table cells. */
 static struct pool *pl_col;	/* For column data. */
 
-static int internal_cmd_crosstabs (struct dataset *ds);
+static int internal_cmd_crosstabs (struct lexer *lexer, struct dataset *ds);
 static void precalc (const struct ccase *, void *, const struct dataset *);
 static bool calc_general (const struct ccase *, void *, const struct dataset *);
 static bool calc_integer (const struct ccase *, void *, const struct dataset *);
@@ -188,9 +188,9 @@
 
 /* Parse and execute CROSSTABS, then clean up. */
 int
-cmd_crosstabs (struct dataset *ds)
+cmd_crosstabs (struct lexer *lexer, struct dataset *ds)
 {
-  int result = internal_cmd_crosstabs (ds);
+  int result = internal_cmd_crosstabs (lexer, ds);
 
   free (variables);
   pool_destroy (pl_tc);
@@ -201,7 +201,7 @@
 
 /* Parses and executes the CROSSTABS procedure. */
 static int
-internal_cmd_crosstabs (struct dataset *ds)
+internal_cmd_crosstabs (struct lexer *lexer, struct dataset *ds)
 {
   int i;
   bool ok;
@@ -213,7 +213,7 @@
   pl_tc = pool_create ();
   pl_col = pool_create ();
 
-  if (!parse_crosstabs (ds, &cmd, NULL))
+  if (!parse_crosstabs (lexer, ds, &cmd, NULL))
     return CMD_FAILURE;
 
   mode = variables ? INTEGER : GENERAL;
@@ -303,7 +303,7 @@
 
 /* Parses the TABLES subcommand. */
 static int
-crs_custom_tables (struct dataset *ds, struct cmd_crosstabs *cmd UNUSED, void *aux UNUSED)
+crs_custom_tables (struct lexer *lexer, struct dataset *ds, struct cmd_crosstabs *cmd UNUSED, void *aux UNUSED)
 {
   struct var_set *var_set;
   int n_by;
@@ -313,11 +313,11 @@
   int success = 0;
 
   /* Ensure that this is a TABLES subcommand. */
-  if (!lex_match_id ("TABLES")
-      && (token != T_ID || dict_lookup_var (dataset_dict (ds), tokid) == NULL)
-      && token != T_ALL)
+  if (!lex_match_id (lexer, "TABLES")
+      && (lex_token (lexer) != T_ID || dict_lookup_var (dataset_dict (ds), lex_tokid (lexer)) == NULL)
+      && lex_token (lexer) != T_ALL)
     return 2;
-  lex_match ('=');
+  lex_match (lexer, '=');
 
   if (variables != NULL)
     var_set = var_set_create_from_array (variables, variables_cnt);
@@ -329,7 +329,7 @@
     {
       by = xnrealloc (by, n_by + 1, sizeof *by);
       by_nvar = xnrealloc (by_nvar, n_by + 1, sizeof *by_nvar);
-      if (!parse_var_set_vars (var_set, &by[n_by], &by_nvar[n_by],
+      if (!parse_var_set_vars (lexer, var_set, &by[n_by], &by_nvar[n_by],
                                PV_NO_DUPLICATE | PV_NO_SCRATCH))
 	goto done;
       if (xalloc_oversized (nx, by_nvar[n_by])) 
@@ -340,11 +340,11 @@
       nx *= by_nvar[n_by];
       n_by++;
 
-      if (!lex_match (T_BY))
+      if (!lex_match (lexer, T_BY))
 	{
 	  if (n_by < 2)
 	    {
-	      lex_error (_("expecting BY"));
+	      lex_error (lexer, _("expecting BY"));
 	      goto done;
 	    }
 	  else 
@@ -407,7 +407,7 @@
 
 /* Parses the VARIABLES subcommand. */
 static int
-crs_custom_variables (struct dataset *ds, struct cmd_crosstabs *cmd UNUSED, void *aux UNUSED)
+crs_custom_variables (struct lexer *lexer, struct dataset *ds, struct cmd_crosstabs *cmd UNUSED, void *aux UNUSED)
 {
   if (nxtab)
     {
@@ -415,7 +415,7 @@
       return 0;
     }
 
-  lex_match ('=');
+  lex_match (lexer, '=');
   
   for (;;)
     {
@@ -424,42 +424,43 @@
 
       long min, max;
       
-      if (!parse_variables (dataset_dict (ds), &variables, &variables_cnt,
+      if (!parse_variables (lexer, dataset_dict (ds), 
+			    &variables, &variables_cnt,
 			    (PV_APPEND | PV_NUMERIC
 			     | PV_NO_DUPLICATE | PV_NO_SCRATCH)))
 	return 0;
 
-      if (token != '(')
+      if (lex_token (lexer) != '(')
 	{
-	  lex_error ("expecting `('");
+	  lex_error (lexer, "expecting `('");
 	  goto lossage;
 	}
-      lex_get ();
+      lex_get (lexer);
 
-      if (!lex_force_int ())
+      if (!lex_force_int (lexer))
 	goto lossage;
-      min = lex_integer ();
-      lex_get ();
+      min = lex_integer (lexer);
+      lex_get (lexer);
 
-      lex_match (',');
+      lex_match (lexer, ',');
 
-      if (!lex_force_int ())
+      if (!lex_force_int (lexer))
 	goto lossage;
-      max = lex_integer ();
+      max = lex_integer (lexer);
       if (max < min)
 	{
 	  msg (SE, _("Maximum value (%ld) less than minimum value (%ld)."),
 	       max, min);
 	  goto lossage;
 	}
-      lex_get ();
+      lex_get (lexer);
 
-      if (token != ')')
+      if (lex_token (lexer) != ')')
 	{
-	  lex_error ("expecting `)'");
+	  lex_error (lexer, "expecting `)'");
 	  goto lossage;
 	}
-      lex_get ();
+      lex_get (lexer);
       
       for (i = orig_nv; i < variables_cnt; i++) 
         {
@@ -470,7 +471,7 @@
           var_attach_aux (variables[i], vr, var_dtor_free);
 	}
       
-      if (token == '/')
+      if (lex_token (lexer) == '/')
 	break;
     }
   
